//
//  SampleViewControllerSimpleSection.m
//  GroupedUITableViews
//
//  Created by Arseniy on 19/7/13.
//  Copyright (c) 2013 Arseniy Kuznetsov. All rights reserved.
//

#import "SampleViewControllerSimpleSection.h"

@implementation SampleViewControllerSimpleSection

// Defines rows in section
enum SampleViewControllerSimpleSectionRows {
    kSampleViewControllerSimpleSectionFirstRow = 0,
    kSampleViewControllerSimpleSectionSecondRow,
    kSampleViewControllerFirstSectionNumRows
};

#pragma mark - GroupedTableSectionsController Table View Data Source
- (NSUInteger)numberOfRows {
    return kSampleViewControllerFirstSectionNumRows;
}
- (void)configureCell:(UITableViewCell *)cell ForRow:(NSUInteger)row {
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    switch (row) {
        case kSampleViewControllerSimpleSectionFirstRow:
            cell.textLabel.text = @"Answer to everything";
            cell.detailTextLabel.text = @"42";
            cell.detailTextLabel.font = [UIFont boldSystemFontOfSize:18];
            break;
        case kSampleViewControllerSimpleSectionSecondRow:
            cell.detailTextLabel.text = @"... besides, it's a Catalan number!";
            break;
        default:
            break;
    }
}

#pragma mark - GroupedTableSectionsController Table View Delegate
- (NSString *)titleForHeaderInSection {
    return @"A simple section";
}
- (CGFloat)heightForHeaderInSection {
    return 32.0f;
}
- (CGFloat)heightForFooterInSection {
    return 20.0f;
}
- (float)heightForRow:(NSInteger)row {
    return 36.0f;
}

@end
