//
//  SampleViewControllerUIController.m
//  GroupedUITableView
//
//  Created by Arseniy on 19/7/13.
//  Copyright (c) 2013 Arseniy Kuznetsov. All rights reserved.
//

#import "SampleViewControllerUIController.h"
#import "SampleViewControllerSimpleSection.h"
#import "SampleViewControllerSuperPowersSection.h"
#import "SampleViewControllerTickerSection.h"
#import "SampleViewControllerTickerSection.h"
#import "SampleViewControllerStartStopTickingButtonSection.h"

// defines the TableView Sections
enum SampleViewControllerSections {
    kSampleViewControllerSimpleSection = 0,
    kSampleViewControllerExpandableSection,
    kSampleViewControllerTickerSection,
    kSampleViewControllerStartStopTickingButtonSection,
    kSampleViewControllerNumSections
};

@implementation SampleViewControllerUIController

// Builds the dispatch table for SampleViewController
- (void)buildSectionsDispatchTable {
    self.grandDispatchTable = @{
        @(kSampleViewControllerSimpleSection):[[SampleViewControllerSimpleSection alloc]
                                  initWithParentViewController:self.parentVC
                                  SectionID:kSampleViewControllerSimpleSection
                                  DefaultCellID:@"kSampleViewControllerSimpleSection"],
        
        @(kSampleViewControllerExpandableSection):[[SampleViewControllerSuperPowersSection alloc]
                                  initWithParentViewController:self.parentVC
                                  SectionID:kSampleViewControllerExpandableSection
                                  DefaultCellID:@"kSampleViewControllerExpandableSection"],
                
        @(kSampleViewControllerTickerSection):[[SampleViewControllerTickerSection alloc]
                                  initWithParentViewController:self.parentVC
                                  SectionID:kSampleViewControllerTickerSection
                                  DefaultCellID:@"kSampleViewControllerTickerSection"],

        @(kSampleViewControllerStartStopTickingButtonSection):
                                  [[SampleViewControllerStartStopTickingButtonSection alloc]
                                  initWithParentViewController:self.parentVC
                                  SectionID:kSampleViewControllerStartStopTickingButtonSection
                                  DefaultCellID:@"kSampleViewControllerStartStopTickingButtonSection"]

        
        };
}
- (NSInteger)numberOfSections {
    return kSampleViewControllerNumSections;
}


@end
