//
//  TRecCounterShadowLabel.m
//  iCasualTours
//
//  Created by Arseniy Kuznetsov on 21/8/11.
//  Copyright (c) 2011 Arseniy Kuznetsov. All rights reserved.
//

#import "ShadowTextLabel.h"

@interface ShadowTextLabel ()
    @property(nonatomic, strong) UIColor *shadowColor;
    @property(nonatomic, assign) CGSize shadowOffset;
    @property(nonatomic, assign) CGFloat shadowRadius;
@end

@implementation ShadowTextLabel

- (void)drawTextInRect:(CGRect)rect {
    if (!self.shadowColor) {
        self.textColor = [ShadowTextLabel UIColorFromRGB:(0xF0F8FF)];
        self.font = [UIFont boldSystemFontOfSize:40];
        self.textAlignment = NSTextAlignmentCenter;
        
        self.shadowColor = self.textColor;
        self.shadowOffset = CGSizeMake(0.0f, 0.0f);
        self.shadowRadius = 14.0f;
    }
    
    CGContextRef context = UIGraphicsGetCurrentContext();
	CGContextSetShadowWithColor(context, self.shadowOffset, self.shadowRadius, [self.shadowColor CGColor]);
    
	[super drawTextInRect:rect];
}

+ (UIColor *)UIColorFromRGB:(NSInteger)rgbValue {
    return [self UIColorFromRGB:rgbValue AndAlpha:1.0];
}
+ (UIColor *)UIColorFromRGB:(NSInteger)rgbValue AndAlpha:(float)theAlpha {
    return [UIColor colorWithRed:((float)((rgbValue & 0xFF0000) >> 16))/255.0
                           green:((float)((rgbValue & 0xFF00) >> 8))/255.0
                            blue:((float)(rgbValue & 0xFF))/255.0
                           alpha:theAlpha];
}

@end
